#include <iostream>
#include "parser.h"
#include "printer.h"
#include "polynomial.h"
#include "division.h"
#include "buchberger.h"
#include "wallideal.h"
#include "lp.h"
#include "reversesearch.h"
#include "termorder.h"
#include "ep_standard.h"
#include "ep_xfig.h"
#include "polyhedralcone.h"
#include "gfanapplication.h"
#include "saturation.h"
#include "field_rationals.h"
#include "field_zmodpz.h"
#include "field_rationalfunctions.h"
#include "symmetry.h"
#include "linalg.h"
#include "fieldlp.h"

class TestApplication : public GFanApplication
{
  FieldOption theFieldOption;
public:
  bool includeInDefaultInstallation()
  {
    return false;
  }
  const char *helpText()
  {
    return "This\n";
  }
  TestApplication()
  {
    registerOptions();
  }

  char *name()
  {
    return "_test";
  }

  Field test(Field &a)
  {
    return a;
  }

  FieldElement test2()
  {
    FieldZModPZ f(3);

    
    return f.zHomomorphism(1);
  }

  FieldElement test3(FieldElement &a)
  {
    return a.one()+a.one()+a;
  }
    
  void lpRationalFunctionTest()
  {
    //int n=3;
	//     IntegerVectorList L=StringParser("{(1,0,2),(1,2,0)}").parseIntegerVectorList();
    //  IntegerVectorList L=StringParser("{(1,2,0)}").parseIntegerVectorList();

    //     int n=4;
    //  IntegerVectorList L=StringParser("{(1,0,2,3),(1,2,3,0)}").parseIntegerVectorList();

    /*     int n=16;
     IntegerVectorList L=StringParser("{(1,0,2,3,5,4,6,7,9,8,10,11,13,12,14,15),"
				      "(3,0,1,2,7,4,5,6,11,8,9,10,15,12,13,14),"
				      "(0,4,8,12,1,5,9,13,2,6,10,14,3,7,11,15)}").parseIntegerVectorList();
    */
    int n=9;
     IntegerVectorList L=StringParser("{(1,0,2,4,3,5,7,6,8),"
				      "(1,2,0,4,5,3,7,8,6),"
				      "(3,4,5,0,1,2,6,7,8),"
				      "(3,4,5,6,7,8,0,1,2)"
				      "}").parseIntegerVectorList();
     /*
    int n=9;
     IntegerVectorList L=StringParser("{(1,0,2,4,3,5,7,6,8),"
				      "(1,2,0,4,5,3,7,8,6),"
				      "(0,3,6,1,4,7,2,5,8)}").parseIntegerVectorList();
     */

    SymmetryGroup s(n);
    s.computeClosure(L);

    FieldRationalFunctions F(Q,"t");
    FieldMatrix M(F,s.elements.size(),n);
    int I=0;
    for(SymmetryGroup::ElementContainer::const_iterator i=s.elements.begin();i!=s.elements.end();i++,I++)
      {
	for(int j=0;j<n;j++)
	  {
	    M[I][j]=M[I][j]+F.exponent(j);
	    M[I][j]=M[I][j]-F.exponent(((SymmetryGroup::inverse(*i))[j]));
	  }
      }
    AsciiPrinter P(Stderr);
    //    M.printMatrix(P);

    
    FieldMatrix M2(Q,M.getHeight(),M.getWidth());
    for(int i=0;i<M.getHeight();i++)
      for(int j=0;j<M.getWidth();j++)
	M2[i][j]=F.substitute(M[i][j],Q.zHomomorphism(10000).inverse());
      
        Field &myField=F;
	{
      M=M2;
      myField=Q;//HERE
      }
    IntegerVectorList extreme;

    M.printMatrix(P);


    I=0;
    FieldElement minusOne=myField.zHomomorphism(-1);//HERE
    for(SymmetryGroup::ElementContainer::const_iterator i=s.elements.begin();i!=s.elements.end();i++,I++)
      //    for(int i=0;i<s.elements.size();i++)
      {
	fprintf(Stderr,"IIII:%i\n",I);
	M[I]=minusOne*M[I];
	FieldVector b(myField,s.elements.size());//HERE
	b[I]=minusOne;
	FieldLP lp(M,b);
	FieldLP lp2=lp.withNoLineality();

	AsciiPrinter P(Stderr);
	//lp2.print(P);

	//	cerr <<"Result" << lp2.findFeasibleBasis()<<endl;

	if(lp2.findFeasibleBasis())
	  extreme.push_back(*i);

	M[I]=minusOne*M[I];
      }
    fprintf(Stdout,"Extreme permutations (%i):\n",extreme.size());
    P.printVectorList(extreme);
  }


  int main()
  {
    lpRationalFunctionTest();
    testRationalFunctionField();
    /*    FieldRationalFunctions F(Q,string("t"));
    AsciiPrinter(Stderr).printField(F);

    
    FieldElement a=F.zHomomorphism(2);

    ((*FieldElementRationalFunction)&(a.implementingObject))->p.toString();
    a.implementingObject->toString();
    /*
    fprintf(stderr,"impl:%x\n",&(a.implementingObject));
    //  FieldElement &(a.implementingObject)
    //  (FieldElementRationalFunction)
    AsciiPrinter(Stderr).printFieldElement(a);
    /*    FieldElement b=F.zHomomorphism(3);

    AsciiPrinter(Stderr).printFieldElement(b);
    FieldElement c=a*b;

    AsciiPrinter(Stderr).printFieldElement(c);
    */
    return 0;
    {



    FieldElement a=Q.zHomomorphism(2);
    FieldElement b=Q.zHomomorphism(3);

    FieldElement c=Q.zHomomorphism(3);
    c=a*b;

    Field QQ(Q);
    QQ=Q;
    QQ=QQ;
    QQ=test(Q);
    QQ=test(Q);

    c=c;
    c=test3(c);

    PolynomialRing R=StringParser("Q[a]").parsePolynomialRing();
    //    Term s=StringParser("a").parseTerm(R);

    FieldElement k(R.getField());
    //    k=R.getField().zHomomorphism(1);
    
    /*
{
    {
      FieldElement k(r.getField());
      k=r.getField().zHomomorphism(1);
      Monomial m=parseMonomial(r);
      return Term(k,m);
    }
}

    */


    //    Polynomial s2=s;

       FieldElement e=test2();
    e*=e*e;
    FieldElement e2=e;


    AsciiPrinter(Stdout).printFieldElement(e);
        AsciiPrinter(Stdout).printField(e.getField());
       
    //  fprintf(Stderr,"Number of living FieldImplementations:%i\n",FieldImplementation::getNumberOfLivingFieldImplementations());

    //    AsciiPrinter(Stdout).printFieldElement(c);
    /*    PolynomialSet g=FileParser(Stdin).parsePolynomialSetWithRing();

    AsciiPrinter(Stdout).printPolynomialSet(nonHomogeneousSaturation(g));
    */


    //    Field FF=c.getField();

    }
    return 0;
  }
};

static TestApplication theApplication;

